
# $Id: rules.mk,v 1.1 1997/02/05 07:03:39 ushijima Exp $

LIBA = lib$(PACKAGE).a
LIBC = lib$(PACKAGE).c
LIBS = lowlev.lib misc.lib useful.lib

distname = $(PACKAGE)-$(VERSION)

all: clu2c.time $(LIBC) $(LIBA) $(LIBS)

install: all $(SYSTYPE)-install

clean: mostlyclean mkclean.bat
	$(MAKE_CLEAN)

mostlyclean: mkmclean.bat
	$(MAKE_MCLEAN)

distclean: clean mkdclean.bat
	$(MAKE_DCLEAN)

dist: files
	rm -fr $(distname) $(distname).tar $(distname).tar.gz
	mkdir $(distname)
	for i in `cat FILES`; do ln -s ../$$i $(distname)/$$i; done
	tar chf $(distname).tar $(distname)
	rm -fr $(distname)
	gzip $(distname).tar
	chmod 444 $(distname).tar.gz

Makefile: config.mk files.mk defs$(SYSTYPE).mk rules.mk
	$(SHELL) $(SHELLFLAGS) mkmf.$(SCR)

$(LIBA): $(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS_SPEC)

$(LIBC): $(CLU_INTS) clu_ints.xload
	$(PLINK) -x -o $@ $(CLU_INTS_SPEC)

clu2c.time: $(CLU_SRCS) external.xload specs.xload clu_srcs.xload
	$(CLU2C) $(CLU2CFLAGS) @external.xload @specs.xload @clu_srcs.xload
	echo time stamp >$@

lowlev.lib: lowlev.xfile
	$(CLU2C) $(CLU2CFLAGS) -f lowlev.xfile

misc.lib: misc.xfile
	$(CLU2C) $(CLU2CFLAGS) -f misc.xfile

useful.lib: useful.xfile
	$(CLU2C) $(CLU2CFLAGS) -f useful.xfile

unix-install:
	$(INSTALL_DATA) $(LIBA) $(DESTDIR)/$(LIBA)
	$(INSTALL_DATA) $(LIBC) $(DESTDIR)/$(LIBC)
	for i in $(LIBS); do $(INSTALL_DATA) $$i $(DESTDIR)/$$i; done
	$(RANLIB) $(DESTDIR)/$(LIBA)

dos-install:
	$(INSTALL_DATA) $(LIBA) $(DESTDIR)\$(LIBA)
	$(INSTALL_DATA) $(LIBC) $(DESTDIR)\$(LIBC)
	for %i in ( $(LIBS) ) do $(INSTALL_DATA) %i $(DESTDIR)\%i
	$(RANLIB) $(DESTDIR)\$(LIBA)

.SUFFIXES:
.SUFFIXES: .o .c .clu

.clu.c:
	rm -f clu2c.time
	$(MAKE) clu2c.time

.c.o:
	$(CC) -I$(CLU2CROOT)/include -w $(CFLAGS) -c $<

# maintenance rules

configure: configure.in
	autoconf

mkclean.bat: clu_ints.xload rules.mk
	for i in clu2c.time $(LIBC) $(LIBS); do echo $$i; done\
	| sort - clu_ints.xload\
	| sed 's/.*/if exist & del &/'\
	> $@

mkdclean.bat: rules.mk
	@echo creating $@;\
	(echo Makefile;\
	 echo config.cache;\
	 echo config.log;\
	 echo config.mk;\
	 echo config.status)\
	| sed 's/.*/if exist & del &/'\
	> $@

mkmclean.bat: objs.xload rules.mk
	echo $(LIBA)\
	| sort - objs.xload\
	| sed 's/.*/if exist & del &/'\
	> $@

clu_srcs.xload: FILES
	grep '\.clu$$' FILES >$@

clu_ints.xload: clu_srcs.xload
	sed 's/\.clu$$/.c/' clu_srcs.xload >$@

objs.xload: FILES
	sed -n -e '/\.clu$$/s//.o/p' -e '/\.c$$/s//.o/p' FILES >$@

files.mk: clu_srcs.xload clu_ints.xload objs.xload rules.mk
	(echo '';\
	 echo '# $@';\
	 echo '';\
	 echo 'CLU_SRCS =\';\
	 sed -e 's/^/	/' -e '$$q' -e 's/$$/\\/' clu_srcs.xload;\
	 echo 'CLU_INTS =\';\
	 sed -e 's/^/	/' -e '$$q' -e 's/$$/\\/' clu_ints.xload;\
	 echo 'OBJS =\';\
	 sed -e 's/^/	/' -e '$$q' -e 's/$$/\\/' objs.xload) >$@

configmk.dos: configmk.in rules.mk
	sed -e 's/@configure_input@//'\
	    -e 's/@PACKAGE@/$(PACKAGE)/'\
	    -e 's/@VERSION@/$(VERSION)/'\
	    -e 's/@CLU2CROOT@/c:\\clu2c/'\
	    -e 's/@CLU2CFLAGS@/-O/'\
	    -e 's/@PLINKFLAGS@//'\
	    -e 's/@CC@/gcc/'\
	    -e 's/@CFLAGS@/-O/'\
	    -e 's/@AR@/ar/'\
	    -e 's/@ARFLAGS@/cru/'\
	    -e 's/@RANLIB@/ranlib/'\
	    -e 's/@SET_MAKE@/MAKE = make/'\
	    -e 's/@INSTALL@/copy/'\
	    -e 's/@INSTALL_PROGRAM@/$$(INSTALL)/'\
	    -e 's/@INSTALL_DATA@/$$(INSTALL)/'\
	    configmk.in >$@

lowlev.xfile: MODULES etc.spc
	./mkxfile lowlev

misc.xfile: MODULES etc.spc
	./mkxfile misc

useful.xfile: MODULES etc.spc
	./mkxfile useful

files:
	$(MAKE) `cat FILES`
